#!/usr/bin/python3.5
#Version 34
import os
import csv

def clean_data(source, temp, skip):
     os.system('sort ' + source + ' | uniq | grep -v "' + skip + '" > ' + temp)
     os.system('cp ' + temp + ' ' + source)

# Head of the webapge
def output_start(file, resource, name):
    file.write('<html>' + '\n')
    file.write('<head>' + '\n')
    file.write('\t<title>' + resource + ': ' + name +  'Stats</title>' + '\n')
    file.write('\t<script type="text/javascript" src="https://www.google.com/jsapi"></script>' + '\n')
    file.write('\t<script type="text/javascript">' + '\n')
    file.write('\tgoogle.load("visualization", "1.1", {packages:["corechart"]});' + '\n')
    file.write('\tgoogle.setOnLoadCallback(setupCharts);' + '\n')
    file.write('\tfunction setupCharts() {' + '\n')
    file.write('\tvar chart = null;' + '\n')

#Before data
def output_top(file, graphnum, units1, units2):
    file.write('\tvar data_' + str(graphnum) +  ' = google.visualization.arrayToDataTable([' + '\n')
    # opposite use of ' and " as e need to out '
    file.write("[{type: 'datetime', label: 'Datetime'},'" + units1 + "','" + units2 + "']\n")

#Before data with one stats
def output_top1(file, graphnum, units1):
    file.write('\tvar data_' + str(graphnum) +  ' = google.visualization.arrayToDataTable([' + '\n')
    # opposite use of ' and " as e need to out '
    file.write("[{type: 'datetime', label: 'Datetime'},'" + units1 + "']\n")

#Before data
def output_top8(file, graphnum, units1, units2, units3, units4, units5, units6, units7, units8):
    file.write('\tvar data_' + str(graphnum) +  ' = google.visualization.arrayToDataTable([' + '\n')
    # opposite use of ' and " as e need to out '
    file.write("[{type: 'datetime', label: 'Datetime'},'" + units1 + "','" + units2 + "','" + units3 + "','" + units4 + "','" + units5 + "','" + units6 + "','" + units7 + "','" + units8 + "']\n")

#Before data
def output_top_unitstring(file, graphnum, unitstring):
    file.write('\tvar data_' + str(graphnum) +  ' = google.visualization.arrayToDataTable([' + '\n')
    # opposite use of ' and " as e need to out '
    file.write("[{type: 'datetime', label: 'Datetime'}," + unitstring  + "]\n")

#Before data but units are supplied as there is a variable number of them
def output_top_no_units(file, graphnum):
    file.write('var data_' + str(graphnum) + ' = google.visualization.arrayToDataTable([\n')

#After  data
def output_bot(file, resource, graphnum, name, description):
    file.write('\t]);\n')
    file.write('\tvar options_'+ str(graphnum) + ' = {\n')
    file.write('\t\tchartArea: {left: "5%", width: "85%", top: "10%", height: "80%"},\n')
    file.write('\t\ttitle: "' + resource +  name + ' - ' + description + ' ",\n')
    file.write('\t\tfocusTarget: "category",\n')
    file.write('\t\thAxis: { gridlines: { color: "lightgrey", count: 30 } },\n')
    file.write('\t\tvAxis: { gridlines: { color: "lightgrey", count: 11 } },\n')
    file.write('\t\texplorer: { actions: ["dragToZoom", "rightClickToReset"],\n')
    file.write('\t\taxis: "horizontal", keepInBounds: true, maxZoomIn: 20.0 },\n')
    file.write('\t\tisStacked:  0\n')
    file.write('\t};\n')
    file.write('\tdocument.getElementById("draw_'+ str(graphnum) + '").addEventListener("click", function() {\n')
    file.write('\tif (chart && chart.clearChart) chart.clearChart();\n')
    file.write('\tchart = new google.visualization.AreaChart(document.getElementById("chart_master"));\n')
    file.write('\tchart.draw( data_'+ str(graphnum) + ', options_'+ str(graphnum) + ');\n')
    file.write('\t});\n')

#Finish off the web page
def output_end(file, name):
    file.write('\t}\n')
    file.write('\t</script>\n')
    file.write('\t</head>\n')
    file.write('\t<body bgcolor="#EEEEFF">\n')
    file.write('\t<b>Server: ' + name + ': </b>\n')
    file.write('\t<button id="draw_1" style="color:red;"><b>Electrical power use in Watts</b></button>\n')
    file.write('\t<button id="draw_2" style="color:blue;"><b>Temperatures in Celsius</b></button>\n')
    file.write('\t<div id="chart_master" style="width:100%; height:85%;">\n')
    file.write('\t<h2 style="color:blue">Click on a Graph button above, to display that graph</h2>\n')
    file.write('\t</div>\n')
    file.write('\n')
    file.write('Author: Nigel Griffiths @mr_nmon generated from HMC REST API  and Python\n')
    file.write('Now with Zoom = Left-click and drag. To Reset = Right-click.\n')
    file.write('</body>\n')
    file.write('</html>\n')

# ----------------

# Sort and remove duplication
clean_data("energy.csv", "energy_clean.csv", "no removeal of lines needed")

#Generate a list of server names and add rows to a list
servernames = set()
serverall = []

with open('energy_clean.csv') as f:
    f_csv = csv.reader(f)
    # no header in Energy stats headers = next(f_csv)
    for row in f_csv:
        serverall.append(row)
        servernames.add(row[0])
#debug
print('Server names:', end='')
print(servernames)

# Take each server one at a time
i = 1
for server in servernames:
    # Extract this single Server's data to a different list
    thisserver = []
    for row in serverall:
        if server == row[0]:
            thisserver.append(row)

    mtm = thisserver[0][1]
    serial = thisserver[0][2]
    print("%d Server=%24s   Machine-Type-Model=%s   Serial-Number=%s" %(i,server,mtm,serial))
    # Open the web page file
    web = open('energy' + server + '.html', "w")
    output_start(web, 'Server', server)

    output_top1(web, 1, 'Watts') 
    for row in thisserver:
            web.write(',[\'Date(' + row[3].replace('-',',')  + ')\',' + row[4] + ']\n')
    output_bot(web,  'Energy:', 1, server, "electrical power in Watts")

    if mtm == '8408-E8E':
        output_top_unitstring(web, 2, "'planar1', 'planar2', 'planar3', 'planar4', 'cpu1', 'cpu2', 'cpu3', 'cpu4', 'cpu5', 'cpu6', 'cpu7', 'cpu8', 'inlet'") 
        for row in thisserver:
                web.write(',[\'Date(' + row[3].replace('-',',')  + ')\',' + row[5] + ',' + row[6] + ',' + row[7] + ',' + row[8] + ',' + row[9] + ',' + row[10] + ',' + row[11] + ',' + row[12] + ',' + row[13] + ',' + row[14] + ',' + row[15] + ',' + row[16] + ',' + row[17] + ']\n')
    else:
        output_top8(web, 2, 'planar1', 'planar2', 'planar3', 'cpu1', 'cpu2', 'cpu3', 'cpu4', 'inlet') 
        for row in thisserver:
                web.write(',[\'Date(' + row[3].replace('-',',')  + ')\',' + row[5] + ',' + row[6]  + ',' + row[7]  + ',' + row[8]  + ',' + row[9]  + ',' + row[10]  + ',' + row[11]  + ',' + row[12]  + ']\n')


    output_bot(web,  'Energy:',2, server, 'Temperature in degrees Celsius. planar=System-Planer cpu=POWER8-Chip inlet=Room-Temp')

    # Finish web page with buttons etc.
    output_end(web,  server)
    web.close()
    i = i + 1

